/* cmd /V:ON
	SetEnv.Cmd /Vista /Release /x64
	rc     /DUNICODE /D_UNICODE "$g.rc"
	cl /LD /DUNICODE /D_UNICODE /EHsc "$f" "$g.def" "$g.res" user32.lib
*/
#include "targetver.h"
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <vector>
#include <utility>
#include <algorithm>

#include "plugin.h"

#define IDS_MENU_TEXT 1
#define IDS_STATUSMESSAGE 2

std::vector<std::pair<LRESULT, HANDLE> >
g_doc2pipe;

// -----------------------------------------------------------------------------
// OnCommand
// vOCsɌĂяo܂
// p[^
//   hwnd: EBhẼnh

EXTERN_C void WINAPI OnCommand(HWND hwnd)
{
	MessageBox(hwnd, L"svn  git ȂǃGfB^vZX̏I҂^CṽvOɑΉ邽߁AMeryRelay2Exe.exe ƋĕҏWIʒm܂B", L"MeryRelay2Plugin", MB_OK);
}

// -----------------------------------------------------------------------------
// QueryStatus
//   vOCs\A܂̓`FbNꂽԂ𒲂ׂ܂
// p[^
//   hwnd:      EBhẼnh
//   pbChecked: `FbN̏
// ߂l
//   s\łTrueԂ܂

EXTERN_C BOOL WINAPI QueryStatus(HWND hwnd, LPBOOL pbChecked)
{
	return true;
}

// -----------------------------------------------------------------------------
// GetMenuTextID
//   j[ɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetMenuTextID()
{
	return IDS_MENU_TEXT;
}

// -----------------------------------------------------------------------------
// GetStatusMessageID
//   c[`bvɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetStatusMessageID()
{
	return IDS_STATUSMESSAGE;
}

// -----------------------------------------------------------------------------
// GetIconID
//   c[o[ɕ\ACR̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetIconID()
{
	return 0;
}

// -----------------------------------------------------------------------------
// OnEvents
//   CxgɌĂяo܂
// p[^
//   hwnd:   EBhẼnh
//   nEvent: Cxg̎
//   lParam: bZ[WL̒ǉ
// l
//   EVENT_CREATE:             GfB^N
//   EVENT_CLOSE:              GfB^I
//   EVENT_CREATE_FRAME:       t[쐬ꂽ
//   EVENT_CLOSE_FRAME:        t[jꂽ
//   EVENT_SET_FOCUS:          tH[JX擾
//   EVENT_KILL_FOCUS:         tH[JX
//   EVENT_FILE_OPENED:        t@CJ
//   EVENT_FILE_SAVED:         t@Cۑ
//   EVENT_MODIFIED:           XV̏ԂύXꂽ
//   EVENT_CARET_MOVED:        J[\ړ
//   EVENT_SCROLL:             XN[ꂽ
//   EVENT_SEL_CHANGED:        I͈͂ύXꂽ
//   EVENT_CHANGED:            eLXgύXꂽ
//   EVENT_CHAR:               ͂ꂽ
//   EVENT_MODE_CHANGED:       ҏW[hύXꂽ
//   EVENT_DOC_SEL_CHANGED:    ANeBuȕύXꂽ
//   EVENT_DOC_CLOSE:          
//   EVENT_TAB_MOVED:          ^uړꂽ
//   EVENT_CUSTOM_BAR_CLOSING: JX^o[悤Ƃ
//   EVENT_CUSTOM_BAR_CLOSED:  JX^o[
//   EVENT_TOOL_BAR_CLOSED:    c[o[
//   EVENT_TOOL_BAR_SHOW:      c[o[\ꂽ
//   EVENT_IDLE:               ACh

EXTERN_C void WINAPI OnEvents(HWND hwnd, UINT nEvent, LPARAM lParam)
{
	// ^
	typedef std::vector<std::pair<LRESULT, HANDLE> >::iterator Iterator;
	struct docIs {
		LRESULT doc;
		docIs(LRESULT doc): doc(doc) {}
		bool operator()(std::pair<LRESULT,HANDLE> p) { return doc == p.first; }
	};

	switch (nEvent)
	{
	case EVENT_DOC_SEL_CHANGED: // t@CJƂAJƂA^u؂ւƂB
	{
		HANDLE hPipe = CreateFile(
			L"\\\\.\\pipe\\MeryRelay2",
			GENERIC_WRITE,
			0,                    // no sharing 
			NULL,                 // default security attributes
			OPEN_EXISTING,        // opens existing pipe 
			FILE_FLAG_OVERLAPPED, // attributes 
			NULL                  // no template file 
 		);
 		if (hPipe == INVALID_HANDLE_VALUE) {
 			break;
 		}

		LRESULT doc = Editor_Info(hwnd, MI_GET_ACTIVE_DOC, 0);
		if (g_doc2pipe.end() != std::find_if(g_doc2pipe.begin(), g_doc2pipe.end(), docIs(doc))) {
			// ^u؂ւAJĂt@CēxJƂă^uANeBuɂȂB
			CloseHandle(hPipe); // QԖڂ Relay vZX͑₩ɏIB
 			break;
		}

		wchar_t path[MAX_PATH];
		path[0] = L'\0';
		Editor_Info(hwnd, MI_GET_FILE_NAME, (LPARAM)path);
		if (! path[0]) {
			CloseHandle(hPipe); // Ȃ̂ Relay ҂IB
			break;
		}

		g_doc2pipe.push_back(std::make_pair(doc, hPipe)); // ^u܂ Relay ҂B
	}
	break;

	case EVENT_DOC_CLOSE:
	{
		Iterator it = std::find_if(g_doc2pipe.begin(), g_doc2pipe.end(), docIs((LRESULT)lParam));
		if (it != g_doc2pipe.end()) {
			CloseHandle(it->second);
			g_doc2pipe.erase(it);
		}
	}		
	break;
	}
}

// -----------------------------------------------------------------------------
// PluginProc
//   vOCɑ郁bZ[W܂
// p[^
//   hwnd:   EBhẼnh
//   nMsg:   bZ[W
//   wParam: bZ[WL̒ǉ
//   lParam: bZ[WL̒ǉ
// ߂l
//   bZ[WɂقȂ܂

EXTERN_C LRESULT WINAPI PluginProc(HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	return	0;
}
